module yamalib.gui.guiparts;

private import y4d;
private import y4d_input.mouse;

class IGUIParts {
public:

	void setXY(int x_,int y_) {
		x = x_; y = y_;
	}
	
	void getXY(out int x_,out int y_) {
		x_ = x; y_ = y;
	}
	
	void setXYOffset(int x,int y) {
		xOffset = x; yOffset = y;
	}
	
	void getXYOffset(out int x, out int y) {
		x = xOffset; y = yOffset;
	}
	
	void onMove(Screen screen) {
	}
	
	void onDraw(Screen screen) {
	}
	
	void setMouse(MouseInput v) {
		reset();
		mouse = v;
	}
	
	/// 自分自身をフォーカス状態にする
	void focus() {
		// 必要なコードを書くこと
	}
	
	MouseInput getMouse() { return mouse; }
	
protected:
	/// 
	void reset() {}
	MouseInput mouse;
	
	int x,y;
	int xOffset,yOffset;
}